#import <Foundation/Foundation.h>
#import <GraphicsServices/GraphicsServices.h>
#import <UIKit/UIKit.h>

// enums for swipe direction in the table
enum kSwipeDirection 
{
	kSwipeDirectionUp	=1, 
	kSwipeDirectionDown	=2, 
	kSwipeDirectionLeft	=4,
	kSwipeDirectionRight=8 
};

@class CDList;

@interface CustomTable : UITable
{
	NSMutableArray*		_dataArray;	
	CDList*				_listPtr;
	int					_selectedCellIndex;
}

- (id) initWithFrame:(CGRect) rect andArray:(NSMutableArray*) a andList: (CDList *)theList;
- (int) swipe:(int)direction withEvent:(struct __GSEvent *)event;
- (void) myReloadData;
- (int) numberOfRowsInTable:(UITable*)table;
- (UITableCell*) table:(UITable*)table cellForRow:(int)row column:(int)column;


@end
