/**
**/
#import <Foundation/Foundation.h>
#import <CoreFoundation/CoreFoundation.h>
#import <UIKit/CDStructures.h>
#import <UIKit/UIApplication.h>
#import <UIKit/UIPushButton.h>
#import <UIKit/UIThreePartButton.h>
#import <UIKit/UINavigationBar.h>
#import <UIKit/UINavBarButton.h>
#import <UIKit/UIWindow.h>
#import <UIKit/UIView.h>
#import <UIKit/UIView-Hierarchy.h>
#import <UIKit/UIHardware.h>
#import <UIKit/UITable.h>
#import <UIKit/UITableCell.h>
#import <UIKit/UITableColumn.h>
#import <UIKit/UIImage.h>
#import <UIKit/UIButtonBar.h>
#import <UIKit/UITextView.h>
#import <UIKit/UIImageView.h>
#import <UIKit/UIKeyboard.h>
#import <UIKit/UIDatePicker.h>
#import <UIKit/UIPreferencesTable.h>
#import <UIKit/UIPreferencesTableCell.h>
#import <UIKit/UIPreferencesTextTableCell.h>
#import <UIKit/UINavigationItem.h>
#import <UIKit/UIImageAndTextTableCell.h>
#import <UIKit/UITextView.h>
#import <UIKit/UITransitionView.h>

@class CDList;
@class iCountDown;
@class ToggleDisplayView;
@class SetupView;

@interface myUIDatePicker : UIDatePicker
{
	SetupView*				_setupView;
}
- (void) pickerViewSelectionChanged:(id)datepicker;
- (void) setPickerViewObject: (SetupView*)theView;
@end

@interface SetupView : UIView
{
	UIPreferencesTable*			_table;
	iCountDown*					_application;
	NSString* 					_applicationID;
	NSMutableArray*				_tableCells;
	id							_delegate;	
	UIPreferencesTableCell* 	_prefGroup;
	UIPreferencesTableCell*		_spacerGroup;
	UINavigationBar* 			_navbar;
	CDList*						_cdlist;
	ToggleDisplayView*			_toggleDisplayView;
	UIView*						_toView;
	UIView*						_mainView;
	UITransitionView*			_transitionView;
	struct CGRect				_rect;
	myUIDatePicker*				_timePicker;
	double						_navBarYSize;
	int							_nameCellIndex;
	NSNumber*					_displayType;
	NSDate*						_counter;
	int							_theSelectedPreference;
	BOOL						_timePickerShown;
}

- (id) initWithApplication: (iCountDown*)app withAppID: (NSString*)appID withFrame: (struct CGRect)rect withCDList: (CDList*)cdlist;
- (void) buildPreferencesTable;
- (void) setDelegate: (id)delegate;
- (void)removeDisplayedItem;
- (void) setCounterValue: (NSDate *)aCounter;
- (void) makeDateSelectorActive;
- (void) makeTimeSelectorActive;
- (void) makeSetupActive;
- (void) makeSetupActive: (NSDate *)aCounter;
- (void) makeCDListActive;
@end